#!/usr/bin/python
##### Uklon na krozni odprtini - S53MV 11.03.2018 #####

import math,cmath	#uporabljene funkcije

ka=0.001	#korak risanja
amax=1		#najvecji polmer odprtine
dt=1		#razdalja do oddajnika
dr=1		#razdalja do sprejemnika
l=0.03		#valovna dolzina
k=2*math.pi/l	#valovno stevilo
r1=math.sqrt(l*dt*dr/(dt+dr))	#r1 prve FC

x=[]		#polja za risanje grafa
y=[]
z=[]

def krozni(a,k,dt,dr):	#tocna integracija uklona krozne odprtine
	dt2=dt*dt
	dr2=dr*dr
	i=0
	kr=0.1/k
	r=kr/2
	while r<a:
		rt=math.sqrt(dt2+r*r)
		rr=math.sqrt(dr2+r*r)
		ct=dt/rt
		cr=dr/rr
		s=(ct+cr)*r/rt/rr
		s=s*cmath.exp(complex(0,-k*rt))
		s=s*cmath.exp(complex(0,-k*rr))
		i=i+s
		r=r+kr
	return abs(i)*kr*(dr+dt)*k/2

a=ka/2		#zacetni a
while a<amax:
	x=x+[a]			#dodaj tocko v risbo
	y=y+[abs(2*math.sin(math.pi/2*(a/r1)**2))]
	z=z+[krozni(a,k,dt,dr)]
	a=a+ka			#povecaj t za korak

import matplotlib.pyplot as plt		#risanje grafa funkcije
fig=plt.figure()
#plt.plot(x,y,'r-')
plt.plot(x,z,'b-')

plt.axis([0,a,0,2.2])
plt.title('Uklon na okrogli odprtini')
plt.yticks([0,1,2],['0',r'$E_\infty$',r'2$E_\infty$'])
plt.xlabel('Polmer odprtine $a$ [m]')
plt.ylabel('Amplituda uklonjenega polja |$E$|')
plt.grid(True)
fig.savefig('krozna.svg', transparent=True)
plt.show()

#konec programa

